#ifndef ENGINE_H_INCLUDED
#define ENGINE_H_INCLUDED

#include "Pokitto.h"
#include "Particle.h"
#include "vector"
#include "algorithm"

class Engine
{

private:
    std::vector<Particle> particles;

public:

    Engine()
    {

    }

    void AddParticle(Particle p)
    {
        particles.push_back(p);
    }

    template<std::size_t col, std::size_t row, std::size_t lenD>
    void update(const std::bitset<8> (&mapProp)[col][row],uint8_t (&mapDestr)[lenD])
    {
        for(auto& p:particles)
        {
            p.update(mapProp,mapDestr);
        }

        //Remove death particles
        particles.erase(
            std::remove_if(particles.begin(),
                            particles.end(),
                            [](Particle &p){return p.life<0;}),
            particles.end());
    }

    void draw(Camera *cam)
    {
        //Draw particles
        for(auto& p:particles)
        {
            p.draw(cam);
        }
    }


};


#endif // ENGINE_H_INCLUDED
