#ifndef PARTICLE_H_INCLUDED
#define PARTICLE_H_INCLUDED

#include "Pokitto.h"

class Particle
{

private:
    Fix16 x;
    Fix16 y;
    Fix16 speed;
    Fix16 angle;


public:
    int16_t life;

    Particle(Fix16 x,Fix16 y,Fix16 speed,Fix16 angle)
    {
        this->x=x;
        this->y=y;
        this->speed=speed;
        this->angle=angle;
        this->life=60;
    }

    int getX()
    {
        return fix16_to_int(x);
    }

    int getY()
    {
        return fix16_to_int(y);
    }

    template<std::size_t col, std::size_t row,std::size_t lenD>
    void update(const std::bitset<8> (&mapProp)[col][row],uint8_t (&mapDestr)[lenD])
    {

        int16_t xcell = getX()/CELL_WIDTH;
        int16_t ycell = getY()/CELL_HEIGHT;
        bool onSolid=mapProp[ycell][xcell][0];
        bool onDestructible=mapProp[ycell][xcell][3];

        if(onSolid)
        {
            angle=random(6)*FOUR_DIV_PI;

            //Find destructible tile life
            for(uint16_t i=0; i<lenD; i+=3)
            {
                if(mapDestr[i]==xcell && mapDestr[i+1]==ycell)//x && y
                {
                    if(mapDestr[i+2]>0)
                        mapDestr[i+2]=0;
                }
            }
        }

        x+=fix16_mul(fix16_sin(angle),speed);
        y+=fix16_mul(fix16_cos(angle),speed);


        life--;
    }

    void draw(Camera *cam)
    {
        d.setColor(5);
        d.drawPixel(getX()-cam->getX(),
                                         getY()-cam->getY());
    }


};


#endif // PARTICLE_H_INCLUDED
