#include "Pokitto.h"

Pokitto::Core g;
Pokitto::Display d;

#include "math.h"
#include "fixmath.h"
#include "gfx.h"
#include "Camera.h"
#include "Player.h"
#include "Layer.h"
#include "Engine.h"

Camera *cam0=new Camera(0,0,2);
Camera *cam1=new Camera(0,0,1);

Layer *layer= new Layer();
Player *p=new Player(88,30);
Engine *engine=new Engine();

void init()
{

};

int main ()
{
    g.begin();
    g.display.load565Palette(pal);
    g.display.setInvisibleColor(0);
    g.setFrameRate(30);

    init();

    while (g.isRunning())
    {
        if (g.update())
        {
            //Cam point to players at center screen
            cam0->setTarget(p->getX()-55,p->getY()-44);
            cam1->setTarget(p->getX()-55,p->getY()-44);
            layer->update();

            cam0->update();
            layer->drawMap(cam0,map_0_data,map_0_renders,map_0_properties,map_0_animations,map_0_destructible);

            cam1->update();
            layer->drawMap(cam1,map_1_data,map_1_renders,map_1_properties,map_1_animations,map_1_destructible);

            p->update(map_1_properties,map_1_destructible,engine);
            p->draw(cam1);

            engine->update(map_1_properties,map_1_destructible);
            engine->draw(cam1);
        }
    }
}

